#include "q1.h"

#include <iostream>
#include <new>

using namespace std ;


static Node* makeNode( int label, Node *next, bool &ok ) {
	if( ok ) {
		Node *t = new(nothrow) Node ;
		if( t==0 ) { ok = false ; return 0; }
		t->label = label ;
		t->next = next ;
	    return t ; }
	else {
		return 0 ; }
}

int testCount() { return 4 ; }

// doTest  --- do one test //
/////////////////////////////
void doTest( int testNumber, int &result ) {
    bool pass = false ;
    try {
        cout << "Test " << testNumber << "\n" ;
        switch( testNumber ) {
        case 0 : {
			bool ok = false ;
			Node *t = 0 ;
			insertAt( t, 99, 0, ok ) ;
			pass = t != 0  && t->label == 99 && t->next == 0 && ok;
		} break ;
        case 1 : {
			bool ok = true ;
			Node *t = makeNode( 17, makeNode( 18, 0, ok ), ok ) ;
			insertAt( t, 22, 0, ok ) ;
			pass = t!=0 && t->next!=0 && t->next->next!=0 && t->next->next->next==0
				 && t->label == 22 && t->next->label == 17 && t->next->next->label == 18 ;
		} break ;
        case 2 : {
			bool ok = true ;
			Node *t = makeNode( 17, makeNode( 18, 0, ok ), ok ) ;
			insertAt( t, 22, 1, ok ) ;
			pass = t!=0 && t->next!=0 && t->next->next!=0 && t->next->next->next==0
				 && t->label == 17 && t->next->label == 22 && t->next->next->label == 18 ;
		} break ;
        case 3 : {
			bool ok = true ;
			Node *t = makeNode( 17, makeNode( 18, 0, ok ), ok ) ;
			insertAt( t, 22, 2, ok ) ;
			pass = t!=0 && t->next!=0 && t->next->next!=0 && t->next->next->next==0
				 && t->label == 17 && t->next->label == 18 && t->next->next->label == 22 ;
		} break ;
        default : pass = false ;
        } }
    catch( ... ) {
        cerr << "Sorry an unanticipated exception occurred\n" ;
        pass = false ; }
	

    if( pass ) {
        cout << "Test " << testNumber << " passes\n" ;
        result = 0 ; }
    else {
        cout << "Test " << testNumber << " fails\n" ;
        result = 1 ; }
}